package com.ashokit.inventory.controller;

import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.ashokit.inventory.dto.InventoryRequestDTO;
import com.ashokit.inventory.dto.InventoryResponseDTO;
import com.ashokit.inventory.service.InventoryService;


import reactor.core.publisher.Flux;

@RestController
@RequestMapping("inventory")
public class InventoryController {
	
	@Autowired
	private InventoryService inventoryService;

	@PostMapping("/deduct")
	public InventoryResponseDTO deduct(@RequestBody InventoryRequestDTO rqRequestDTO) {
		return inventoryService.deduct(rqRequestDTO);
		
	}
	
	@PostMapping("/add")
	public void add(@RequestBody InventoryRequestDTO rqRequestDTO) {
		inventoryService.add(rqRequestDTO);
	}
	
	
	@GetMapping("/all")
	public Map<Integer, Integer>  getInventory() {
		return  inventoryService.getAllInvetory();
	}
}
