package com.ashokit.payment.controller;

import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.ashokit.payment.dto.PaymentRequestDTO;
import com.ashokit.payment.dto.PaymentResponseDTO;
import com.ashokit.payment.service.PaymentService;

@RestController
@RequestMapping("payment")
public class PaymentControler {
	
	@Autowired
	private PaymentService paymentService;
	
	@PostMapping("/debit")
	public PaymentResponseDTO debit(@RequestBody PaymentRequestDTO requestDTO) {
		return paymentService.debit(requestDTO);
	}
	
	@PostMapping("/credit")
	public void credit(@RequestBody PaymentRequestDTO requestDTO) {
		paymentService.credit(requestDTO);
	}

	
	@GetMapping("/all")
	public Map<Integer, Double>  getInventory() {
		return  paymentService.getAllPayments();
	}
}
